/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ij2x.plugin.event;
import java.awt.event.ComponentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ComponentAdapter;

import java.awt.Container;
import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JWindow;
/**
 *
 * @author Mahdi Rawak
 */
public class MoveComponentListener extends ComponentAdapter{
    private JComponent target;
    private Point start_drag;
    private Point start_loc;
    private boolean dragging;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;

    public MoveComponentListener(final JComponent target) {
        this.target = target;
		/*target.addComponentListener(new ComponentAdapter() {
			public void componentMoved(ComponentEvent e) {
				Point current = getScreenLocation(e);
				//palette.setLocation(new Point(p.x-palette.getWidth()-10,p.y));

            Point offset = new Point(
                (int)current.getX()-(int)start_drag.getX(),
                (int)current.getY()-(int)start_drag.getY());
            JWindow frame = getFrame(target);
            Point new_location = new Point(
                (int)(start_loc.getX()+offset.getX()),
                (int)(start_loc.getY()+offset.getY()));
            frame.setLocation(new_location);
			}
		});*/
    }
			public void componentMoved(ComponentEvent e) {
				Point current = getScreenLocation(e);

            Point offset = new Point(
                (int)current.getX()-(int)start_drag.getX(),
                (int)current.getY()-(int)start_drag.getY());
            JWindow frame = getFrame(target);
            Point new_location = new Point(
                (int)(start_loc.getX()+offset.getX()),
                (int)(start_loc.getY()+offset.getY()));
            frame.setLocation(new_location);
			}

    public static JWindow getFrame(Container target) {
        if(target instanceof JWindow) {
            return (JWindow)target;
        }
        return getFrame(target.getParent());
    }

    Point getScreenLocation(ComponentEvent e) {
        Point cursor = e.getComponent().getLocation();
        Point target_location = this.target.getLocationOnScreen();
        return new Point(
            (int)(target_location.getX()+cursor.getX()),
            (int)(target_location.getY()+cursor.getY()));
    }
    //ComponentListener methods
    public void componentHidden(ComponentEvent e) {}
    public void componentShown(ComponentEvent e) {}
    //public void componentMoved(ComponentEvent e) {}
    public void componentResized(ComponentEvent e) {}

}
